#include <CActiveAsyncIO.rsg>

#include "CFileIO.h"
#include "CSummaryDialog.h"

CFileIO::CFileIO(TDesC&fileName, TInt mBytes)
	: CActive(CActive::EPriorityStandard), mBytes(mBytes * 2)
{
	CActiveScheduler::Add(this);
	iFsSession.Connect();
	TInt err = iDataFile.Open(iFsSession, fileName, EFileShareAny);
	switch(err)
	{
	case KErrNone:
		break;
	case KErrNotFound: 
		err = iDataFile.Create(iFsSession,fileName,EFileShareAny);
	   	User::LeaveIfError(err);
	   	break;
	default:
		User::Leave(err);
	}
	currTime.HomeTime();
}

void CFileIO::RunL() {
	mBytes--;
	if (mBytes != 0) {
		go();
		return;
	} 
		
	iDataFile.Close();
	TTime now;
	now.HomeTime();
	TInt64 ms = now.MicroSecondsFrom(currTime).Int64();
	TReal s = ms.GetTReal() / 1000000;
	CSummaryDialog* dialog = new (ELeave) CSummaryDialog(s);
	dialog -> ExecuteLD(R_SUMMARY_DIALOG);
	User::Exit(0);
}

TInt CFileIO::RunError(TInt aError) {
	return aError;
}

void CFileIO::DoCancel() {
}

CFileIO::~CFileIO()
{
}
