/*
============================================================================
 Name        : DLL.h
 Author      : 
 Copyright   : Your copyright notice
 Description : DLL.h - CDLL class header
============================================================================
*/

// This file defines the API for DLL.dll

#ifndef __DLL_H__
#define __DLL_H__


//  Include Files

#include <e32base.h>    // CBase
#include <e32std.h>     // TBuf


//  Constants

const TInt KDLLBufferLength = 15;
typedef TBuf<KDLLBufferLength> TDLLExampleString;


//  Class Definitions

class CDLL : public CBase
    {
    public:     // new functions
        IMPORT_C static CDLL* NewL();
        IMPORT_C static CDLL* NewLC();
        IMPORT_C ~CDLL();

    public:     // new functions, example API
        IMPORT_C TVersion Version() const;
        IMPORT_C void FuncAddCharL(const TChar& aChar);
        IMPORT_C void FuncRemoveLast();
        IMPORT_C const TPtrC FuncString() const;

    private:    // new functions
        CDLL();
        void ConstructL();

    private:    // data
        TDLLExampleString* iString;
    };


#endif  // __DLL_H__


